
Imports System
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid


'/ <summary>
'/ Summary description for Form1.
'/ </summary>

Public Class Form1
    Inherits System.Windows.Forms.Form
    Private gridControl1 As Syncfusion.Windows.Forms.Grid.GridControl
    Private WithEvents button1 As System.Windows.Forms.Button
    '/ <summary>
    '/ Required designer variable.
    '/ </summary>
    Private components As System.ComponentModel.Container = Nothing
    
    
    Public Sub New()
        '
        ' Required for Windows Form Designer support
        '
        InitializeComponent()
    End Sub 'New
     
    '
    ' TODO: Add any constructor code after InitializeComponent call
    '
    
    '/ <summary>
    '/ Clean up any resources being used.
    '/ </summary>
    Protected Overrides Sub Dispose(disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose
    
    #Region "Windows Form Designer generated code"
    
    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.gridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl()
        Me.button1 = New System.Windows.Forms.Button()
        CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        ' 
        ' gridControl1
        ' 
        Me.gridControl1.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right
        Me.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.gridControl1.ColCount = 15
        Me.gridControl1.Location = New System.Drawing.Point(40, 32)
        Me.gridControl1.Name = "gridControl1"
        Me.gridControl1.RowCount = 60
        Me.gridControl1.Size = New System.Drawing.Size(432, 256)
        Me.gridControl1.TabIndex = 0
        Me.gridControl1.Text = "gridControl1"
        ' 
        ' button1
        ' 
        Me.button1.Anchor = System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left
        Me.button1.Location = New System.Drawing.Point(224, 304)
        Me.button1.Name = "button1"
        Me.button1.Size = New System.Drawing.Size(88, 23)
        Me.button1.TabIndex = 1
        Me.button1.Text = "Print Preview"
        ' 
        ' Form1
        ' 
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(512, 333)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.button1, Me.gridControl1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
    End Sub 'InitializeComponent 
    #End Region
    
    
    '/ <summary>
    '/ The main entry point for the application.
    '/ </summary>
    <STAThread()>  _
    Shared Sub Main()
        Application.Run(New Form1())
    End Sub 'Main
    
    
    Private Sub button1_Click(sender As Object, e As System.EventArgs) Handles button1.Click
        'printpreview
        If Not (gridControl1 Is Nothing) Then
            Try
                Dim pd As New GridPrintAtLocDocument(gridControl1, True) 'Assumes the default printer 
                Dim dlg As New PrintPreviewDialog()
                dlg.Document = pd
                dlg.ShowDialog()
            Catch ex As Exception
                MessageBox.Show("An error occurred attempting to preview - " + ex.Message)
            End Try
        End If
    End Sub 'button1_Click
End Class 'Form1


Public Class GridPrintAtLocDocument
    Inherits GridPrintDocument
    Private _grid As GridControlBase
    
    Private headerHeight As Integer
    
    Private footerHeight As Integer
    
    Private pageNo As Integer
    
    
    Public Sub New(grid As GridControlBase, printPreview As Boolean)
        MyBase.New(grid, printPreview)
        _grid = grid
        
        headerHeight = 50
        footerHeight = 20
        
        Dim left As Integer = Me.DefaultPageSettings.Margins.Left
        Dim top As Integer = Me.DefaultPageSettings.Margins.Top + headerHeight '50 lower
        Dim right As Integer = Me.DefaultPageSettings.Margins.Right
        Dim bottom As Integer = Me.DefaultPageSettings.Margins.Bottom
        Me.DefaultPageSettings.Margins = New Margins(left, right, top, bottom)
        
        pageNo = 1
    End Sub 'New
    
    
    Protected Overrides Sub OnPrintPage(ev As System.Drawing.Printing.PrintPageEventArgs)
        MyBase.OnPrintPage(ev)
        
        'compute the position of the header
        Dim x As Single = System.Convert.ToSingle(Me.DefaultPageSettings.Bounds.X) 'this.DefaultPageSettings.Margins.Left;
        Dim y As Single = System.Convert.ToSingle(Me.DefaultPageSettings.Margins.Top) - headerHeight - 30
        Dim w As Single = System.Convert.ToSingle(Me.DefaultPageSettings.Bounds.Width)
        Dim h As Single = System.Convert.ToSingle(headerHeight) + 30
        
        'setup the alignment
        Dim format As New StringFormat()
        format.LineAlignment = StringAlignment.Center
        format.Alignment = StringAlignment.Center
        
        'define the header text and draw it
        Dim [text] As String = String.Format("Header Text {0}", pageNo)
        Dim font As New Font(_grid.Font.Name, 30)
        ev.Graphics.DrawString([text], font, Brushes.Black, New RectangleF(x, y, w, h), format)
        
        'position the footer; align the footer ; print the footer
        y = System.Convert.ToSingle(Me.DefaultPageSettings.Bounds.Top + Me.DefaultPageSettings.Bounds.Height - footerHeight) ' Margins.Top - headerHeight - 30;
        h = System.Convert.ToSingle(footerHeight)
        
        format.Alignment = StringAlignment.Far
        
        [text] = String.Format("Footer Text {0} of {1}", pageNo, Me.PrinterSettings.MaximumPage)
        font = New Font(_grid.Font.Name, 10)
        ev.Graphics.DrawString([text], font, Brushes.Black, New RectangleF(x, y, w, h), format)
        
        pageNo += 1
    End Sub 'OnPrintPage
End Class 'GridPrintAtLocDocument


